/************************************************************************
 *   IRC - Internet Relay Chat, include/msg.h
 *   Copyright (C) 1990 Jarkko Oikarinen and
 *                      University of Oulu, Computing Center
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 1, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

/* $Id: msg.h,v 1.31 2002/10/09 00:07:47 lucas Exp $ */

#ifndef	__msg_include__
#define __msg_include__

#define MSG_PRIVMSG  "PRIVMSG"		/* PRIV */
#define MSG_WHO      "WHO"	      	/* WHO  -> WHOC */
#define MSG_WHOIS    "WHOIS"	   	/* WHOI */
#define MSG_WHOWAS   "WHOWAS"	   	/* WHOW */
#define MSG_USER     "USER"	   	/* USER */
#define MSG_NICK     "NICK"	   	/* NICK */
#define MSG_SERVER   "SERVER"	   	/* SERV */
#define MSG_LIST     "LIST"	   	/* LIST */
#define MSG_TOPIC    "TOPIC"	   	/* TOPI */
#define MSG_INVITE   "INVITE"	   	/* INVI */
#define MSG_VERSION  "VERSION"		/* VERS */
#define MSG_QUIT     "QUIT"	   	/* QUIT */
#define MSG_SQUIT    "SQUIT"	   	/* SQUI */
#define MSG_KILL     "KILL"	   	/* KILL */
#define MSG_INFO     "INFO"	   	/* INFO */
#define MSG_LINKS    "LINKS"	   	/* LINK */
#define MSG_STATS    "STATS"	   	/* STAT */
#define MSG_USERS    "USERS"	   	/* USER -> USRS */
#define MSG_HELP     "HELP"	   	/* HELP */
#define MSG_ERROR    "ERROR"	   	/* ERRO */
#define MSG_AWAY     "AWAY"	   	/* AWAY */
#define MSG_CONNECT  "CONNECT"		/* CONN */
#define MSG_PING     "PING"	   	/* PING */
#define MSG_PONG     "PONG"	   	/* PONG */
#define MSG_OPER     "OPER"	   	/* OPER */
#define MSG_PASS     "PASS"	   	/* PASS */
#define MSG_WALLOPS  "WALLOPS"		/* WALL */
#define MSG_TIME     "TIME"	   	/* TIME */
#define MSG_NAMES    "NAMES"	   	/* NAME */
#define MSG_ADMIN    "ADMIN"	   	/* ADMI */
#define MSG_TRACE    "TRACE"	   	/* TRAC */
#define MSG_NOTICE   "NOTICE"	   	/* NOTI */
#define MSG_JOIN     "JOIN"	   	/* JOIN */
#define MSG_PART     "PART"	   	/* PART */
#define MSG_LUSERS   "LUSERS"	   	/* LUSE */
#define MSG_MOTD     "MOTD"	   	/* MOTD */
#define MSG_MODE     "MODE"	   	/* MODE */
#define MSG_KICK     "KICK"	   	/* KICK */
#define MSG_USERHOST "USERHOST"		/* USER -> USRH */
#define MSG_ISON     "ISON"	   	/* ISON */
#define MSG_REHASH   "REHASH"	   	/* REHA */
#define MSG_RESTART  "RESTART"		/* REST */
#define MSG_CLOSE    "CLOSE"	   	/* CLOS */
#define MSG_SVINFO   "SVINFO"	   	/* SVINFO */
#define MSG_SJOIN    "SJOIN"	   	/* SJOIN */
#define MSG_DIE	     "DIE" 		/* DIE */
#define MSG_HASH     "HASH"	   	/* HASH */
#define MSG_DNS      "DNS"   	   	/* DNS  -> DNSS */
#define MSG_GLOBOPS  "GLOBOPS"		/* GLOBOPS */
#define MSG_CHATOPS  "CHATOPS"		/* CHATOPS */
#define MSG_GOPER    "GOPER"	   	/* GOPER */
#define MSG_GNOTICE  "GNOTICE"		/* GNOTICE */
#define MSG_KLINE    "KLINE"	   	/* KLINE */
#ifdef UNKLINE
#define MSG_UNKLINE  "UNKLINE"		/* UNKLINE */
#endif
#define MSG_HTM      "HTM"	      	/* HTM */
#define MSG_SET      "SET"	      	/* SET */
#define MSG_SAMODE   "SAMODE"    	/* SAMODE */
#define MSG_CHANSERV "CHANSERV"		/* CHANSERV */
#define MSG_NICKSERV "NICKSERV"		/* NICKSERV */
#define MSG_MEMOSERV "MEMOSERV"		/* MEMOSERV */
#define MSG_OPERSERV "OPERSERV"		/* OPERSERV */
#define MSG_STATSERV "STATSERV" 	/* STATSERV */
#define MSG_HELPSERV "HELPSERV"		/* HELPSERV */
#define MSG_ROOTSERV "ROOTSERV"		/* ROOTSERV */
#define MSG_SERVICES "SERVICES"		/* SERVICES */
#define MSG_IDENTIFY "IDENTIFY"		/* IDENTIFY */
#define MSG_CAPAB    "CAPAB"	   	/* CAPAB */ 
#define MSG_LOCOPS   "LOCOPS"	   	/* LOCOPS */
#define MSG_SVSNICK  "SVSNICK"   	/* SVSNICK */
#define MSG_SVSNOOP  "SVSNOOP"   	/* SVSNOOP */
#define MSG_SVSKILL  "SVSKILL"   	/* SVSKILL */
#define MSG_SVSMODE  "SVSMODE"   	/* SVSMODE */
#define MSG_AKILL    "AKILL"     	/* AKILL */
#define MSG_RAKILL   "RAKILL"    	/* RAKILL */
#define MSG_SILENCE  "SILENCE"   	/* SILENCE */
#define MSG_WATCH    "WATCH"     	/* WATCH */
#define MSG_SQLINE   "SQLINE" 		/* SQLINE */
#define MSG_UNSQLINE "UNSQLINE" 	/* UNSQLINE */
#define MSG_BURST    "BURST"     	/* BURST */
#define MSG_DCCALLOW "DCCALLOW"		/* dccallow */
#define MSG_MYID     "MYID"		/* MYID */
#define MSG_SGLINE   "SGLINE"           /* sgline */
#define MSG_UNSGLINE "UNSGLINE"         /* unsgline */
#define MSG_DKEY     "DKEY"		/* dkey */
#define MSG_NS       "NS"               /* NickServ commands */
#define MSG_CS       "CS"               /* ChanServ commands */
#define MSG_MS       "MS"               /* MemoServ commands */
#define MSG_RS       "RS"               /* RootServ commands */
#define MSG_OS       "OS"               /* OperServ commands */
#define MSG_SS       "SS"               /* StatServ commands */
#define MSG_HS       "HS"               /* StatServ commands */
#define MSG_DWHOIS   "DWHOIS"           /* debug whois */

#define MAXPARA      15

extern int  m_kline(aClient *, aClient *, int, char **);
extern int  m_unkline(aClient *, aClient *, int, char **);
extern int  m_akill(aClient *, aClient *, int, char **);
extern int  m_rakill(aClient *, aClient *, int, char **);
extern int  m_locops(aClient *, aClient *, int, char **);
extern int  m_private(aClient *, aClient *, int, char **);
extern int  m_topic(aClient *, aClient *, int, char **);
extern int  m_join(aClient *, aClient *, int, char **);
extern int  m_part(aClient *, aClient *, int, char **);
extern int  m_mode(aClient *, aClient *, int, char **);
extern int  m_ping(aClient *, aClient *, int, char **);
extern int  m_pong(aClient *, aClient *, int, char **);
extern int  m_wallops(aClient *, aClient *, int, char **);
extern int  m_kick(aClient *, aClient *, int, char **);

extern int  m_privmsg_directed(aClient *, aClient *, int, char **);
extern int  m_notice_directed(aClient *, aClient *, int, char **);

extern int  u_nick(aClient *, aClient *, int, char **);
extern int  s_nick(aClient *, aClient *, int, char **);

extern int  m_error(aClient *, aClient *, int, char **);
extern int  m_notice(aClient *, aClient *, int, char **);
extern int  m_invite(aClient *, aClient *, int, char **);
extern int  m_quit(aClient *, aClient *, int, char **);
extern int  m_kill(aClient *, aClient *, int, char **);
extern int  m_motd(aClient *, aClient *, int, char **);
extern int  m_who(aClient *, aClient *, int, char **);
extern int  m_whois(aClient *, aClient *, int, char **);
extern int  u_user(aClient *, aClient *, int, char **);
extern int  m_list(aClient *, aClient *, int, char **);
extern int  m_server(aClient *, aClient *, int, char **);
extern int  m_info(aClient *, aClient *, int, char **);
extern int  m_links(aClient *, aClient *, int, char **);
extern int  m_summon(aClient *, aClient *, int, char **);
extern int  m_stats(aClient *, aClient *, int, char **);
extern int  m_users(aClient *, aClient *, int, char **);
extern int  m_chanserv(aClient *, aClient *, int, char **);
extern int  m_nickserv(aClient *, aClient *, int, char **);
extern int  m_operserv(aClient *, aClient *, int, char **);
extern int  m_statserv(aClient *, aClient *, int, char **);
extern int  m_helpserv(aClient *, aClient *, int, char **);
extern int  m_rootserv(aClient *, aClient *, int, char **);
extern int  m_memoserv(aClient *, aClient *, int, char **);
extern int  m_services(aClient *, aClient *, int, char **);
extern int  m_identify(aClient *, aClient *, int, char **);
extern int  m_svsnick(aClient *, aClient *, int, char **);
extern int  m_svsnoop(aClient *, aClient *, int, char **);
extern int  m_svskill(aClient *, aClient *, int, char **);
extern int  m_svsmode(aClient *, aClient *, int, char **);
extern int  m_version(aClient *, aClient *, int, char **);
extern int  m_help(aClient *, aClient *, int, char **);
extern int  m_squit(aClient *, aClient *, int, char **);
extern int  m_away(aClient *, aClient *, int, char **);
extern int  m_connect(aClient *, aClient *, int, char **);
extern int  u_oper(aClient *, aClient *, int, char **);
extern int  m_pass(aClient *, aClient *, int, char **);
extern int  m_trace(aClient *, aClient *, int, char **);
extern int  m_time(aClient *, aClient *, int, char **);
extern int  m_names(aClient *, aClient *, int, char **);
extern int  m_admin(aClient *, aClient *, int, char **);
extern int  m_lusers(aClient *, aClient *, int, char **);
extern int  m_umode(aClient *, aClient *, int, char **);
extern int  m_close(aClient *, aClient *, int, char **);
extern int  m_motd(aClient *, aClient *, int, char **);
extern int  m_whowas(aClient *, aClient *, int, char **);
extern int  m_userhost(aClient *, aClient *, int, char **);
extern int  m_ison(aClient *, aClient *, int, char **);
extern int  m_svinfo(aClient *, aClient *, int, char **);
extern int  m_sjoin(aClient *, aClient *, int, char **);
extern int  m_samode(aClient *, aClient *, int, char **);
extern int  m_globops(aClient *, aClient *, int, char **);
extern int  m_chatops(aClient *, aClient *, int, char **);
extern int  m_goper(aClient *, aClient *, int, char **);
extern int  m_gnotice(aClient *, aClient *, int, char **);
extern int  m_rehash(aClient *, aClient *, int, char **);
extern int  m_restart(aClient *, aClient *, int, char **);
extern int  m_die(aClient *, aClient *, int, char **);
extern int  m_hash(aClient *, aClient *, int, char **);
extern int  m_dns(aClient *, aClient *, int, char **);
extern int  m_htm(aClient *, aClient *, int, char **);
extern int  m_set(aClient *, aClient *, int, char **);
extern int  m_capab(aClient *, aClient *, int, char **);
extern int  m_silence(aClient *, aClient *, int, char **);
extern int  m_watch(aClient *, aClient *, int, char **);
extern int  m_sqline(aClient *, aClient *, int, char **);
extern int  m_unsqline(aClient *, aClient *, int, char **);
extern int  m_burst(aClient *, aClient *, int, char **);
extern int  m_dccallow(aClient *, aClient *, int, char **);
extern int  m_myid(aClient *, aClient *, int, char **);
extern int  m_sgline(aClient *, aClient *, int, char **);
extern int  m_unsgline(aClient *, aClient *, int, char **);
extern int  m_dkey(aClient *, aClient *, int, char **);
extern int  m_dwhois(aClient *, aClient *, int, char **);

#ifdef MSGTAB
struct Message user_msgtab[] = {
   {MSG_PRIVMSG, m_private, 0, MAXPARA, 1, 0, 1, 0L},
   {MSG_NICK, u_nick, 0, MAXPARA, 1, 1, 0, 0L},
   {MSG_NOTICE, m_notice, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_JOIN, m_join, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_MODE, m_mode, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_SAMODE, m_samode, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_QUIT, m_quit, 0, MAXPARA, 1, 1, 0, 0L},
   {MSG_PART, m_part, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_TOPIC, m_topic, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_INVITE, m_invite, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_KICK, m_kick, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_WALLOPS, m_wallops, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_LOCOPS, m_locops, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_PONG, m_pong, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_PING, m_ping, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_ERROR, m_error, 0, MAXPARA, 1, 1, 0, 0L},
   {MSG_KILL, m_kill, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_USER, u_user, 0, MAXPARA, 1, 1, 0, 0L},
   {MSG_AWAY, m_away, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_ISON, m_ison, 0, 1, 1, 0, 0, 0L},
   {MSG_SERVER, m_server, 0, MAXPARA, 1, 1, 0, 0L},
   {MSG_SQUIT, m_squit, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_WHOIS, m_whois, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_WHO, m_who, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_WHOWAS, m_whowas, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_LIST, m_list, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_NAMES, m_names, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_USERHOST, m_userhost, 0, 1, 1, 0, 0, 0L},
   {MSG_TRACE, m_trace, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_PASS, m_pass, 0, MAXPARA, 1, 1, 0, 0L},
   {MSG_LUSERS, m_lusers, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_TIME, m_time, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_OPER, u_oper, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_CONNECT, m_connect, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_VERSION, m_version, 0, MAXPARA, 1, 1, 0, 0L},
   {MSG_STATS, m_stats, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_LINKS, m_links, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_ADMIN, m_admin, 0, MAXPARA, 1, 1, 0, 0L},
   {MSG_USERS, m_users, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_HELP, m_help, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_INFO, m_info, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_MOTD, m_motd, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_SVINFO, m_svinfo, 0, MAXPARA, 1, 1, 0, 0L},
   {MSG_SJOIN, m_sjoin, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_GLOBOPS, m_globops, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_CHATOPS, m_chatops, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_GOPER, m_goper, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_GNOTICE, m_gnotice, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_CLOSE, m_close, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_KLINE, m_kline, 0, MAXPARA, 1, 0, 0, 0L},
# ifdef UNKLINE
   {MSG_UNKLINE, m_unkline, 0, MAXPARA, 1, 0, 0, 0L},
# endif
   {MSG_HASH, m_hash, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_DNS, m_dns, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_REHASH, m_rehash, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_RESTART, m_restart, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_DIE, m_die, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_HTM, m_htm, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_SET, m_set, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_CHANSERV, m_chanserv, 0, 1, 1, 0, 0, 0L},
   {MSG_NICKSERV, m_nickserv, 0, 1, 1, 0, 0, 0L},
   {MSG_OPERSERV, m_operserv, 0, 1, 1, 0, 0, 0L},
   {MSG_STATSERV, m_statserv, 0, 1, 1, 0, 0, 0L},
   {MSG_HELPSERV, m_helpserv, 0, 1, 1, 0, 0, 0L},
   {MSG_ROOTSERV, m_rootserv, 0, 1, 1, 0, 0, 0L},
   {MSG_RS, m_rootserv, 0, 1, 1, 0, 0, 0L},
   {MSG_CS, m_chanserv, 0, 1, 1, 0, 0, 0L},
   {MSG_NS, m_nickserv, 0, 1, 1, 0, 0, 0L},
   {MSG_OS, m_operserv, 0, 1, 1, 0, 0, 0L},
   {MSG_SS, m_statserv, 0, 1, 1, 0, 0, 0L},
   {MSG_HS, m_helpserv, 0, 1, 1, 0, 0, 0L},
   {MSG_MS, m_memoserv, 0, 1, 1, 0, 0, 0L},
   {MSG_MEMOSERV, m_memoserv, 0, 1, 1, 0, 0, 0L},
   {MSG_SERVICES, m_services, 0, 1, 1, 0, 0, 0L},
   {MSG_IDENTIFY, m_identify, 0, 1, 1, 0, 0, 0L},
   {MSG_SVSNICK,  m_svsnick,  0, MAXPARA, 1, 0, 0, 0L},
   {MSG_SVSNOOP,  m_svsnoop,  0, MAXPARA, 1, 0, 0, 0L},
   {MSG_SVSKILL,  m_svskill,  0, MAXPARA, 1, 0, 0, 0L},	 
   {MSG_SVSMODE,  m_svsmode,  0, MAXPARA, 1, 0, 0, 0L},	 
   {MSG_AKILL,    m_akill,    0, MAXPARA, 1, 0, 0, 0L},
   {MSG_RAKILL,   m_rakill,   0, MAXPARA, 1, 0, 0, 0L}, 
   {MSG_SILENCE,  m_silence,  0, MAXPARA, 1, 0, 0, 0L },
   {MSG_WATCH, m_watch, 0, 1, 1, 0, 0, 0L },
   {MSG_DCCALLOW, m_dccallow, 0, 1, 1, 0, 0, 0L },
   {MSG_SQLINE, m_sqline, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_UNSQLINE, m_unsqline, 0, MAXPARA, 1, 0, 0, 0L },
   {MSG_CAPAB, m_capab, 0, MAXPARA, 1, 1, 0, 0L},
   {MSG_MYID, m_myid, 0, MAXPARA, 1, 1, 0, 0L},
   {MSG_BURST, m_burst, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_SGLINE, m_sgline, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_UNSGLINE, m_unsgline, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_DKEY, m_dkey, 0, MAXPARA, 1, 1, 0, 0L},
   {MSG_DWHOIS, m_dwhois, 0, MAXPARA, 1, 0, 0, 0L},
   {(char *) 0, (int (*)()) 0, 0, 0, 0, 0, 0, 0L}
};

struct Message server_msgtab[] = {
   {MSG_PRIVMSG, m_private, 0, MAXPARA, 1, 0, 1, 0L},
   {MSG_NICK, s_nick, 0, MAXPARA, 1, 1, 0, 0L},
   {MSG_NOTICE, m_notice, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_JOIN, m_join, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_MODE, m_mode, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_SAMODE, m_samode, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_QUIT, m_quit, 0, MAXPARA, 1, 1, 0, 0L},
   {MSG_PART, m_part, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_TOPIC, m_topic, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_INVITE, m_invite, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_KICK, m_kick, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_WALLOPS, m_wallops, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_LOCOPS, m_locops, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_PONG, m_pong, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_PING, m_ping, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_ERROR, m_error, 0, MAXPARA, 1, 1, 0, 0L},
   {MSG_KILL, m_kill, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_AWAY, m_away, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_ISON, m_ison, 0, 1, 1, 0, 0, 0L},
   {MSG_SERVER, m_server, 0, MAXPARA, 1, 1, 0, 0L},
   {MSG_SQUIT, m_squit, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_WHOIS, m_whois, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_WHO, m_who, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_WHOWAS, m_whowas, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_LIST, m_list, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_NAMES, m_names, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_USERHOST, m_userhost, 0, 1, 1, 0, 0, 0L},
   {MSG_TRACE, m_trace, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_PASS, m_pass, 0, MAXPARA, 1, 1, 0, 0L},
   {MSG_LUSERS, m_lusers, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_TIME, m_time, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_CONNECT, m_connect, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_VERSION, m_version, 0, MAXPARA, 1, 1, 0, 0L},
   {MSG_STATS, m_stats, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_LINKS, m_links, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_ADMIN, m_admin, 0, MAXPARA, 1, 1, 0, 0L},
   {MSG_USERS, m_users, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_HELP, m_help, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_INFO, m_info, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_MOTD, m_motd, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_SVINFO, m_svinfo, 0, MAXPARA, 1, 1, 0, 0L},
   {MSG_SJOIN, m_sjoin, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_GLOBOPS, m_globops, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_CHATOPS, m_chatops, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_GOPER, m_goper, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_GNOTICE, m_gnotice, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_CLOSE, m_close, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_KLINE, m_kline, 0, MAXPARA, 1, 0, 0, 0L},
# ifdef UNKLINE
   {MSG_UNKLINE, m_unkline, 0, MAXPARA, 1, 0, 0, 0L},
# endif
   {MSG_HASH, m_hash, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_DNS, m_dns, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_REHASH, m_rehash, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_RESTART, m_restart, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_DIE, m_die, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_HTM, m_htm, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_SET, m_set, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_CHANSERV, m_chanserv, 0, 1, 1, 0, 0, 0L},
   {MSG_NICKSERV, m_nickserv, 0, 1, 1, 0, 0, 0L},
   {MSG_OPERSERV, m_operserv, 0, 1, 1, 0, 0, 0L},
   {MSG_STATSERV, m_statserv, 0, 1, 1, 0, 0, 0L},
   {MSG_MEMOSERV, m_memoserv, 0, 1, 1, 0, 0, 0L},
   {MSG_SERVICES, m_services, 0, 1, 1, 0, 0, 0L},
   {MSG_IDENTIFY, m_identify, 0, 1, 1, 0, 0, 0L},
   {MSG_SVSNICK,  m_svsnick,  0, MAXPARA, 1, 0, 0, 0L},
   {MSG_SVSNOOP,  m_svsnoop,  0, MAXPARA, 1, 0, 0, 0L},
   {MSG_SVSKILL,  m_svskill,  0, MAXPARA, 1, 0, 0, 0L},	 
   {MSG_SVSMODE,  m_svsmode,  0, MAXPARA, 1, 0, 0, 0L},	 
   {MSG_AKILL,    m_akill,    0, MAXPARA, 1, 0, 0, 0L},
   {MSG_RAKILL,   m_rakill,   0, MAXPARA, 1, 0, 0, 0L}, 
   {MSG_SILENCE,  m_silence,  0, MAXPARA, 1, 0, 0, 0L },
   {MSG_WATCH, m_watch, 0, 1, 1, 0, 0, 0L },
   {MSG_DCCALLOW, m_dccallow, 0, 1, 1, 0, 0, 0L },
   {MSG_SQLINE, m_sqline, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_UNSQLINE, m_unsqline, 0, MAXPARA, 1, 0, 0, 0L },
   {MSG_CAPAB, m_capab, 0, MAXPARA, 1, 1, 0, 0L},
   {MSG_MYID, m_myid, 0, MAXPARA, 1, 1, 0, 0L},
   {MSG_BURST, m_burst, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_SGLINE, m_sgline, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_UNSGLINE, m_unsgline, 0, MAXPARA, 1, 0, 0, 0L},
   {MSG_DKEY, m_dkey, 0, MAXPARA, 1, 1, 0, 0L},
   {MSG_DWHOIS, m_dwhois, 0, MAXPARA, 1, 0, 0, 0L},
   {(char *) 0, (int (*)()) 0, 0, 0, 0, 0, 0, 0L}
};
#else
extern struct Message user_msgtab[];
extern struct Message server_msgtab[];
#endif /* MSGTAB */

#define TOK1_ADMIN "d" /* ADMIN */
#define TOK1_AKILL "a" /* AKILL */
#define TOK1_AWAY "A" /* AWAY */
#define TOK1_BURST "B" /* BURST */
#define TOK1_CHATOPS "C" /* CHATOPS */
#define TOK1_CONNECT "c" /* CONNECT */
#define TOK1_ERROR "E" /* ERROR */
#define TOK1_GLOBOPS "L" /* GLOBOPS */
#define TOK1_GNOTICE "G" /* GNOTICE */
#define TOK1_GOPER "g" /* GOPER */
#define TOK1_HTM "H" /* HTM */
#define TOK1_INVITE "I" /* INVITE */
#define TOK1_JOIN "J" /* JOIN */
#define TOK1_KICK "K" /* KICK */
#define TOK1_KILL "k" /* KILL */
#define TOK1_MODE "M" /* MODE */
#define TOK1_MOTD "m" /* MOTD */
#define TOK1_NICK "N" /* NICK */
#define TOK1_NOTICE "n" /* NOTICE */
#define TOK1_PART "p" /* PART */
#define TOK1_PING "f" /* PING */
#define TOK1_PONG "u" /* PONG */
#define TOK1_PRIVMSG "P" /* PRIVMSG */
#define TOK1_QUIT "Q" /* QUIT */
#define TOK1_RAKILL "R" /* RAKILL */
#define TOK1_VERSION "v" /* VERSION */
#define TOK1_SERVER "s" /* SERVER */
#define TOK1_SJOIN "S" /* SJOIN */
#define TOK1_SGLINE "5" /* SGLINE */
#define TOK1_SQLINE "x" /* SQLINE */
#define TOK1_SQUIT "q" /* SQUIT */
#define TOK1_STATS "?" /* STATS */
#define TOK1_SVINFO "z" /* SVINFO */
#define TOK1_SVSKILL "1" /* SVSKILL */
#define TOK1_SVSMODE "2" /* SVSMODE */
#define TOK1_SVSNICK "3" /* SVSNICK */
#define TOK1_SVSNOOP "4" /* SVSNOOP */
#define TOK1_TOPIC "T" /* TOPIC */
#define TOK1_TRACE "t" /* TRACE */
#define TOK1_TIME "i" /* TIME */
#define TOK1_UNSGLINE "6" /* UNSGLINE */
#define TOK1_UNSQLINE "U" /* UNSQLINE */
#define TOK1_WALLOPS "l" /* WALLOPS */
#define TOK1_WHOIS "W" /* WHOIS */
#define TOK1_WHOWAS "w" /* WHOWAS */
#define TOK1_PRIVMSG_DIRECTED "[" /* PRIVMSG -D */
#define TOK1_NOTICE_DIRECTED "]" /* NOTICE -D */

#ifdef TOK1TAB
#include "msgtok1.h"
#endif

#ifdef TOK1_USEFUL
struct tok1 {
   int (*func) ();
   unsigned int count;
   int parameters;
   unsigned long int bytes;
};

# ifdef TOK1TAB
struct tok1 tok1tab[256] = {
   /* The first 32 will never be used by us. */
      { NULL, 0, MAXPARA, 0L}, /* 0 */
      { NULL, 0, MAXPARA, 0L}, /* 1 */
      { NULL, 0, MAXPARA, 0L}, /* 2 */
      { NULL, 0, MAXPARA, 0L}, /* 3 */
      { NULL, 0, MAXPARA, 0L}, /* 4 */
      { NULL, 0, MAXPARA, 0L}, /* 5 */
      { NULL, 0, MAXPARA, 0L}, /* 6 */
      { NULL, 0, MAXPARA, 0L}, /* 7 */
      { NULL, 0, MAXPARA, 0L}, /* 8 */
      { NULL, 0, MAXPARA, 0L}, /* 9 */
      { NULL, 0, MAXPARA, 0L}, /* 10 */
      { NULL, 0, MAXPARA, 0L}, /* 11 */
      { NULL, 0, MAXPARA, 0L}, /* 12 */
      { NULL, 0, MAXPARA, 0L}, /* 13 */
      { NULL, 0, MAXPARA, 0L}, /* 14 */
      { NULL, 0, MAXPARA, 0L}, /* 15 */
      { NULL, 0, MAXPARA, 0L}, /* 16 */
      { NULL, 0, MAXPARA, 0L}, /* 17 */
      { NULL, 0, MAXPARA, 0L}, /* 18 */
      { NULL, 0, MAXPARA, 0L}, /* 19 */
      { NULL, 0, MAXPARA, 0L}, /* 20 */
      { NULL, 0, MAXPARA, 0L}, /* 21 */
      { NULL, 0, MAXPARA, 0L}, /* 22 */
      { NULL, 0, MAXPARA, 0L}, /* 23 */
      { NULL, 0, MAXPARA, 0L}, /* 24 */
      { NULL, 0, MAXPARA, 0L}, /* 25 */
      { NULL, 0, MAXPARA, 0L}, /* 26 */
      { NULL, 0, MAXPARA, 0L}, /* 27 */
      { NULL, 0, MAXPARA, 0L}, /* 28 */
      { NULL, 0, MAXPARA, 0L}, /* 29 */
      { NULL, 0, MAXPARA, 0L}, /* 30 */
      { NULL, 0, MAXPARA, 0L}, /* 31 */
      { NULL, 0, MAXPARA, 0L}, /* 32 */
   /* REAL commands start here */
      { NULL, 0, MAXPARA, 0L}, /* ! */ /* DO NOT USE THIS! IT IS A PREFIX! */
      { NULL, 0, MAXPARA, 0L}, /* " */
      { NULL, 0, MAXPARA, 0L}, /* # */
      { NULL, 0, MAXPARA, 0L}, /* $ */
      { NULL, 0, MAXPARA, 0L}, /* % */
      { NULL, 0, MAXPARA, 0L}, /* & */
      { NULL, 0, MAXPARA, 0L}, /* ' */
      { NULL, 0, MAXPARA, 0L}, /* ( */
      { NULL, 0, MAXPARA, 0L}, /* ) */
      { NULL, 0, MAXPARA, 0L}, /* * */
      { NULL, 0, MAXPARA, 0L}, /* + */
      { NULL, 0, MAXPARA, 0L}, /* , */
      { NULL, 0, MAXPARA, 0L}, /* - */
      { NULL, 0, MAXPARA, 0L}, /* . */
      { NULL, 0, MAXPARA, 0L}, /* / */
      { NULL, 0, MAXPARA, 0L}, /* 0 */
      { m_svskill, 0, MAXPARA, 0L}, /* 1 SVSKILL */
      { m_svsmode, 0, MAXPARA, 0L}, /* 2 SVSMODE */
      { m_svsnick, 0, MAXPARA, 0L}, /* 3 SVSNICK */
      { m_svsnoop, 0, MAXPARA, 0L}, /* 4 SVSNOOP */
      { m_sgline, 0, MAXPARA, 0L}, /* 5 SGLINE */
      { m_unsgline, 0, MAXPARA, 0L}, /* 6 SUNGLINE */
      { NULL, 0, MAXPARA, 0L}, /* 7 */
      { NULL, 0, MAXPARA, 0L}, /* 8 */
      { NULL, 0, MAXPARA, 0L}, /* 9 */
      { NULL, 0, MAXPARA, 0L}, /* : */ /* DO NOT USE THIS! IT IS A PREFIX! */
      { NULL, 0, MAXPARA, 0L}, /* ; */
      { NULL, 0, MAXPARA, 0L}, /* < */
      { NULL, 0, MAXPARA, 0L}, /* = */
      { NULL, 0, MAXPARA, 0L}, /* > */
      { m_stats, 0, MAXPARA, 0L}, /* ? STATS */
      { NULL, 0, MAXPARA, 0L}, /* @ */
      { m_away, 0, MAXPARA, 0L}, /* A AWAY */
      { m_burst, 0, MAXPARA, 0L}, /* B BURST */
      { m_chatops, 0, MAXPARA, 0L}, /* C CHATOPS */
      { NULL, 0, MAXPARA, 0L}, /* D */
      { m_error, 0, MAXPARA, 0L}, /* E ERROR */
      { NULL, 0, MAXPARA, 0L}, /* F */
      { m_gnotice, 0, MAXPARA, 0L}, /* G GNOTICE */
      { NULL, 0, MAXPARA, 0L}, /* H */
      { m_invite, 0, MAXPARA, 0L}, /* I INVITE */
      { m_join, 0, MAXPARA, 0L}, /* J JOIN */
      { m_kick, 0, MAXPARA, 0L}, /* K KICK */
      { m_globops, 0, MAXPARA, 0L}, /* L GLOBOPS */
      { m_mode, 0, MAXPARA, 0L}, /* M MODE */
      { m_notice, 0, MAXPARA, 0L}, /* N NOTICE */
      { NULL, 0, MAXPARA, 0L}, /* O */
      { m_private, 0, MAXPARA, 0L}, /* P PRIVMSG */
      { m_quit, 0, MAXPARA, 0L}, /* Q QUIT */
      { m_rakill, 0, MAXPARA, 0L}, /* R RAKILL */
      { m_sjoin, 0, MAXPARA, 0L}, /* S SJOIN */
      { m_topic, 0, MAXPARA, 0L}, /* T TOPIC */
      { m_unsqline, 0, MAXPARA, 0L}, /* U UNSQLINE*/
      { NULL, 0, MAXPARA, 0L}, /* V */
      { m_whois, 0, MAXPARA, 0L}, /* W WHOIS */
      { NULL, 0, MAXPARA, 0L}, /* X */
      { NULL, 0, MAXPARA, 0L}, /* Y */
      { NULL, 0, MAXPARA, 0L}, /* Z */
      { m_privmsg_directed, 0, MAXPARA, 0L}, /* [ */
      { NULL, 0, MAXPARA, 0L}, /* \ */
      { m_notice_directed, 0, MAXPARA, 0L}, /* ] */
      { NULL, 0, MAXPARA, 0L}, /* ^ */
      { NULL, 0, MAXPARA, 0L}, /* _ */
      { NULL, 0, MAXPARA, 0L}, /* ` */
      { m_akill, 0, MAXPARA, 0L}, /* a AKILL */
      { NULL, 0, MAXPARA, 0L}, /* b */
      { m_connect, 0, MAXPARA, 0L}, /* c CONNECT */
      { m_admin, 0, MAXPARA, 0L}, /* d ADMIN */
      { NULL, 0, MAXPARA, 0L}, /* e */
      { m_ping, 0, MAXPARA, 0L}, /* f PING */
      { m_goper, 0, MAXPARA, 0L}, /* g GOPER */
      { NULL, 0, MAXPARA, 0L}, /* h */
      { m_time, 0, MAXPARA, 0L}, /* i TIME */
      { NULL, 0, MAXPARA, 0L}, /* j */
      { m_kill, 0, MAXPARA, 0L}, /* k KILL */
      { m_wallops, 0, MAXPARA, 0L}, /* l WALLOPS */
      { m_motd, 0, MAXPARA, 0L}, /* m MOTD */
      { m_notice, 0, MAXPARA, 0L}, /* n NOTICE */
      { NULL, 0, MAXPARA, 0L}, /* o */
      { m_part, 0, MAXPARA, 0L}, /* p PART */
      { m_squit, 0, MAXPARA, 0L}, /* q SQUIT */
      { NULL, 0, MAXPARA, 0L}, /* r */
      { m_server, 0, MAXPARA, 0L}, /* s SERVER */
      { m_trace, 0, MAXPARA, 0L}, /* t TRACE */
      { m_pong, 0, MAXPARA, 0L}, /* u PONG */
      { m_version, 0, MAXPARA, 0L}, /* v VERSION */
      { m_whowas, 0, MAXPARA, 0L}, /* w WHOWAS */
      { m_sqline, 0, MAXPARA, 0L}, /* x SQLINE */
      { NULL, 0, MAXPARA, 0L}, /* y */
      { m_svinfo, 0, MAXPARA, 0L}, /* z SVINFO */
      { NULL, 0, MAXPARA, 0L}, /* { */
      { NULL, 0, MAXPARA, 0L}, /* | */
      { NULL, 0, MAXPARA, 0L}, /* } */
      { NULL, 0, MAXPARA, 0L}, /* ~ */
      { NULL, 0, MAXPARA, 0L}, /* UNPRINTABLE!!!!!! DO NOT USE!!!! */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L}, /*  */
      { NULL, 0, MAXPARA, 0L} /*  */   
};
# endif /* TOK1TAB */
#endif /* TOK1_USEFUL */

struct msg_pointer {
   char *message;
   char *token;
};


#include "msgptr.h"

#endif /* __msg_include__  */
