/************************************************************************
 *   IRC - Internet Relay Chat, include/h.h
 *   Copyright (C) 1992 Darren Reed
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 1, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/*
 * "send.h". - Headers file.
 * 
 * all the send* functions are declared here.
 */

/* $Id: send.h,v 1.20 2002/04/25 17:27:57 lucas Exp $ */

#ifndef SEND_H
#define SEND_H

/* send all queued crap to aClient */
extern int  send_queued(aClient *);

#include <stdarg.h>
#include "fdlist.h"
#include "msg.h"

#define NOPRE 0
#define COLONPRE ':'

extern void init_send();

extern void send_chatops(char *pattern, ...);
extern void send_globops(char *pattern, ...);
extern void send_operwall(aClient *, char *, char *);

extern void sendto_all_butone(aClient *one, aClient *from, char *pattern, ...);
extern void sendto_channel_butone(aClient *one, aClient *from, aChannel *chptr, char *pattern, ...);
extern void sendto_channel_butserv(aChannel *chptr, aClient *from, char *pattern, ...);
extern void sendto_channelops_butone(aClient *one, aClient *from, aChannel *chptr,char *pattern, ...);
extern void sendto_channelvoice_butone(aClient *one, aClient *from, aChannel *chptr, char *pattern, ...);
extern void sendto_channelvoiceops_butone(aClient *one, aClient *from, aChannel *chptr, char *patern, ...);
extern void sendto_common_channels(aClient *user, char *pattern, ...);
extern void sendto_fdlist(fdlist *listp, char *pattern, ...);
extern void sendto_locops(char *pattern, ...);
extern void sendto_match_butone(aClient *one, aClient *from, char *mask, int what, char *pattern, ...);
extern void sendto_match_servs(aChannel *chptr, aClient *from, char *format, ...);
extern void sendto_one(aClient *to, char *pattern, ...);
extern void sendto_ops(char *pattern, ...);
extern void sendto_ops_butone(aClient *one, aClient *from, char *pattern, ...);
extern void sendto_ops_lev(int lev, char *pattern, ...);
extern void sendto_prefix_one(aClient *to, aClient *from, char *pattern, ...);

extern void sendto_realops_lev(int lev, char *pattern, ...);
extern void sendto_realops(char *pattern, ...);
extern void sendto_serv_butone(aClient *one, char *pattern, ...);
extern void sendto_wallops(aClient *from, char *pattern, ...);
extern void sendto_gnotice(char *pattern, ...);

extern void ts_warn(char *pattern, ...);

extern void sendto_ssjoin_servs(int ssjoin, aChannel *chptr, aClient *from, char *pattern, ...);
extern void sendto_flag_serv_butone(aClient *one, int include, int exclude, char *pattern, ...);

extern void send_serv_message_butone(aClient *one, aClient *from, aClient *to, 
                                     struct msg_pointer *message, char *pattern, ...);
extern void send_flag_serv_message_butone(aClient *one, int include, int exclude,
                                   aClient *from, aClient *to, struct msg_pointer *message,
                                   char *pattern, ...);
extern void sendto_one_client(aClient *to, aClient *from, struct msg_pointer *message, char *pattern, ...);
extern void sendto_one_client_real(aClient *realto, aClient *to, aClient *from, 
                                   struct msg_pointer *message, char *pattern, ...);
extern void sendto_one_client_nopostfix(aClient *to, aClient *from, struct msg_pointer *message, char *pattern, ...);
extern void sendto_one_client_nopostfix_copy(aClient *to, aClient *from, struct msg_pointer *message, int doprefix, char *mtxt);
extern void sendto_one_client_prefixed(aClient *to, aClient *from, struct msg_pointer *message, char *pattern, ...);
extern void sendto_one_client_prefixed_copy(aClient *to, aClient *from, struct msg_pointer *message, int doprefix, char *pmsg);
extern void sendto_client_numeric(aClient *to, aClient *from, int numeric, ...);
extern void sendto_one_clientonserver(aClient *to, aClient *from, struct msg_pointer *message, char *pattern, ...);
extern void sendto_one_clientonserver_copy(aClient *to, aClient *from, struct msg_pointer *message, int doprefix, char *pmsg);
extern void send_channel_message_butone(aClient *one, aClient *from, aChannel *chptr, char *chname, 
                                        struct msg_pointer *msg, char *pattern, ...);
extern void send_channel_message_butone_copy(aClient *one, aClient *from, aChannel *chptr, char *chname, 
                                             struct msg_pointer *msg, int doprefix, char *mtxt);
extern void send_channelflags_message_butone_copy(aClient *one, aClient *from, aChannel *chptr, int flags, 
                                                  char *chname, struct msg_pointer *msg, 
                                                  int doprefix, char *mtxt);
extern void send_channelflags_message_butone(aClient *one, aClient *from, aChannel *chptr, int flags, 
                                             char *chname, struct msg_pointer *msg, char *pattern, ...);
extern void send_channel_message_localremote_butone(int dolocal, aClient *one, aClient *from, aChannel *chptr, 
                                                    char *chname, struct msg_pointer *msg, char *pattern, ...);
extern void send_channel_message_localremote_butone_copy(int dolocal, aClient *one, aClient *from, aChannel *chptr, 
                                                    char *chname, struct msg_pointer *msg, 
                                                    int doprefix, char *mtxt);


#define send_channel_message_local(from, chptr, msg, pattern, args...) \
             send_channel_message_localremote_butone(1, NULL, from, chptr, chptr->chname, msg, pattern, args)
#define send_channel_message_local_copy(from, chptr, msg, doprefix, mtxt) \
             send_channel_message_localremote_butone_copy(1, NULL, from, chptr, chptr->chname, msg, doprefix, mtxt)

#define send_channel_message_local_butone(one, from, chptr, msg, pattern, args...) \
             send_channel_message_localremote_butone(1, one, from, chptr, chptr->chname, msg, pattern, args)
#define send_channel_message_local_butone_copy(one, from, chptr, msg, doprefix, txt) \
             send_channel_message_localremote_butone_copy(1, one, from, chptr, chptr->chname, msg, doprefix, txt)

/* these macros should work as long as they are called with at least 1 argument.. */
#define send_me_notice(to, pat, args...) sendto_one_client(to, &me, &CMD_NOTICE, pat, args)
#define send_me_noticeNA(to, pat) sendto_one_client(to, &me, &CMD_NOTICE, pat)
#define send_me_numeric(to, numeric, args...) sendto_client_numeric(to, &me, numeric, args)
#define send_me_numericNA(to, numeric) sendto_client_numeric(to, &me, numeric)

extern void vsendto_fdlist(fdlist *listp, char *pattern, va_list vl);
extern void vsendto_one(aClient *to, char *pattern, va_list vl);
extern void vsendto_prefix_one(aClient *to, aClient *from, char *pattern, va_list vl);
extern void vsendto_realops(char *pattern, va_list vl);

extern void flush_connections();
extern void dump_connections();
#endif
